u_angle         =   0
gametime        =   0
HOVER           =   false

function love.load()
    rect_img            =   love.graphics.newImage("rectangle.png")
    rect_img_hovered    =   love.graphics.newImage("rectangle_hovered.png")
    img                 =   rect_img
    offset_x, offset_y  =   rect_img:getWidth()/2, rect_img:getHeight()/2
end

function love.keyreleased(key, unicode)
    if key==" " then
        print("Toggling offset")
        if offset_x == 0 then
            offset_x, offset_y  =   rect_img:getWidth()/2, rect_img:getHeight()/2
        else
            offset_x, offset_y  =   0, 0
        end
    end
end

function love.draw()
    love.graphics.setColor(255, 255, 255)
    love.graphics.draw( img, 200, 200, u_angle, 1, 1, offset_x, offset_y )

end

function love.update(dt)
    gametime    =   gametime + dt
    if love.keyboard.isDown("left") then
        u_angle = u_angle + math.pi/100
    elseif love.keyboard.isDown("right") then
        u_angle = u_angle - math.pi/100
    end

    m_x, m_y    =   love.mouse:getPosition()
    HOVER = point_vs_raabb (m_x, m_y, 200, 200, rect_img:getWidth()/2, rect_img:getHeight()/2, -u_angle)
    if HOVER then
        img =   rect_img_hovered
    else
        img =   rect_img
    end
end

function love.quit()
  print("Played "..gametime.." seconds, leaving game...")

end

------------------------------------------------------------------------
function change_angle ( x, y, a )
  local cd = math.cos ( a )
  local sd = math.sin ( a )
  return cd*x - sd*y, cd*y + sd*x
end
-- accepts a point (x, y), aabb center (rx, ry), aabb half-width/half-height (hw, hh) and an angle in radians (a)
function point_vs_raabb ( x, y, rx, ry, hw, hh, a )
  -- translate point to aabb origin
  --~ print ("Testing point "..x.." "..y)
  local lx, ly = x - rx, y - ry
  -- rotate point
  lx, ly = change_angle ( lx, ly, a )

    --~ print("Rotated point is "..lx.." "..ly)
    --~ print("is lx("..lx..") < "..-hw.. "or lx >"..hw)
  -- perform regular point vs aabb test
  if lx < -hw or lx > hw then
     return false
  end
  if ly < -hh or ly > hh then
     return false
  end
  return true
end
